=== debian/changelog ===
waffle (1.8.0-2build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:54:43 +0200

waffle (1.8.0-2) unstable; urgency=medium

  [ Simon McVittie ]
  * d/control: Add missing dependency libwaffle-dev -> libdrm-dev
    (Closes: #1053836)
  * d/control: libwaffle-dev no longer needs to depend on libudev-dev
  * d/tests: Add superficial autopkgtests

 -- Jordan Justen <jljusten@debian.org>  Sat, 21 Oct 2023 03:21:58 -0700

waffle (1.8.0-1) unstable; urgency=medium

  * New upstream release
  * d/control: Upstream replaced libudev dep with libdrm

 -- Jordan Justen <jljusten@debian.org>  Fri, 06 Oct 2023 16:25:26 -0700
