=== debian/control ===
Source: waffle
Priority: optional
Section: libs
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jordan Justen <jljusten@debian.org>
Build-Depends: bash-completion,
               debhelper-compat (= 13),
               dh-exec,
               docbook-xml,
               docbook-xsl,
               libdrm-dev,
               libegl1-mesa-dev | libegl-dev,
               libgbm-dev,
               libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libwayland-dev,
               libx11-xcb-dev,
               meson,
               pkg-config,
               python3,
               python3-setuptools,
               wayland-protocols,
               xsltproc
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://waffle.freedesktop.org/
Vcs-Git: https://salsa.debian.org/xorg-team/lib/waffle.git
Vcs-Browser: https://salsa.debian.org/xorg-team/lib/waffle

Package: libwaffle-1-0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Waffle library (binaries)
 A library for selecting an OpenGL API and window system at runtime
 .
 This package contains the waffle runtime shared library.

Package: libwaffle-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdrm-dev,
         libegl-dev,
         libgbm-dev,
         libgl-dev,
         libwaffle-1-0 (= ${binary:Version}),
         libwayland-dev,
         libx11-xcb-dev,
         ${misc:Depends}
Suggests: libwaffle-doc
Description: Waffle library (development files)
 A library for selecting an OpenGL API and window system at runtime
 .
 This package provides the development environment for compiling
 programs against the waffle library.

Package: libwaffle-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Waffle library (documentation)
 A library for selecting an OpenGL API and window system at runtime
 .
 This package provides the documentation files for the waffle
 library.

Package: waffle-utils
Architecture: any
Section: utils
Depends: libwaffle-1-0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Waffle library (utilities)
 A library for selecting an OpenGL API and window system at runtime
 .
 This package contains waffle utilities:
  * wflinfo: Creates an OpenGL context and prints information about
             the created context.
