=== debian/rules ===
#!/usr/bin/make -f
# Copyright (c) 2013 Intel Corporation

DEB_DESTDIR := $(CURDIR)/debian/tmp

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=meson --builddirectory=build/

confflags += \
	-D gbm=enabled \
	-D glx=enabled \
	-D surfaceless_egl=enabled \
	-D x11_egl=enabled \
	-D wayland=enabled \
	-D build-manpages=true \
	-D build-htmldocs=false \
	-D build-examples=false

override_dh_auto_configure:
	$(buildflags) dh_auto_configure -- \
		$(confflags)

override_dh_missing-indep:
	dh_missing --list-missing
