=== src/CMakeLists.txt ===
add_subdirectory(utils)
add_subdirectory(waffle)
