=== third_party/cmocka/doc/CMakeLists.txt ===
#
# Build the documentation
#
include(UseDoxygen OPTIONAL)
