=== debian/changelog ===
waffle (1.8.1-1) unstable; urgency=medium

  * New upstream release
  * d/control: Update Standards-Version to 4.7.0
  * d/control: Change build-dep pkg-config to pkgconf

 -- Jordan Justen <jljusten@debian.org>  Fri, 09 Aug 2024 14:40:30 -0700
