=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: waffle
 Priority: optional
 Section: libs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jordan Justen <jljusten@debian.org>
+Maintainer: Jordan Justen <jljusten@debian.org>
 Build-Depends: bash-completion,
                debhelper-compat (= 13),
                dh-exec,
@@ -16,12 +15,12 @@
                libwayland-dev,
                libx11-xcb-dev,
                meson,
-               pkg-config,
+               pkgconf,
                python3,
                python3-setuptools,
                wayland-protocols,
                xsltproc
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://waffle.freedesktop.org/
 Vcs-Git: https://salsa.debian.org/xorg-team/lib/waffle.git
