=== debian/tests/control ===
Tests: build
Restrictions: allow-stderr, superficial
Depends:
 build-essential,
 libwaffle-dev,
 pkgconf,

Tests: info
Restrictions: superficial
Depends:
 waffle-utils,
