## waffle hub-0.1.1

=== requirements.txt ===
# print utils
tqdm
tabulate==0.9.0
pydantic
typer[all]
rich
onnxruntime

# pytorch
torch==1.13.1
torchaudio==0.13.1
torchvision==0.14.1

# waffle dependencies
waffle-utils==0.2.2
