## waffle hub-0.1.3

=== requirements.txt ===
--- 
+++ 
@@ -5,6 +5,7 @@
 typer[all]
 rich
 onnxruntime
+tbparse==0.0.7
 
 # pytorch
 torch==1.13.1
@@ -13,3 +14,4 @@
 
 # waffle dependencies
 waffle-utils==0.2.2
+ultralytics==8.0.54
