## waffle utils-0.1.2

=== requirements.txt ===
tqdm
wget==3.2
PyYAML==6.0
typer[all]
rich
